<script>
import SvgIcon from "@/components/SvgIcon.vue";

export default {
  name: "ReSidebar",
  components: {
    SvgIcon,
  },
  props: {
    sideBarList: {
      type: Array,
      default: () => [],
      required: true,
    }, // 传数组, name 是底部名字, icon 是图标
    activeIndex: {
      type: Number,
      default: 0,
      required: true,
    }, // 默认选中项
  },
  computed: {
    active: {
      get() {
        return this.activeIndex;
      },
    },
  },
  methods: {
    handleClick(clickedItem, index) {
      this.$forceUpdate();
      this.$emit("click", clickedItem, index);
    },
  },
};
</script>

<template>
  <div class="sidebar-container">
    <slot name="header" />
    <div class="sidebar-container-main">
      <div
        v-for="(item, index) in sideBarList"
        :class="{
          'sidebar-container-main-item': true,
          active: active === index,
        }"
        :key="index"
        @click.stop="handleClick(item, index)"
      >
        <div class="sidebar-container-main-item-icon">
          <SvgIcon :icon-class="item.icon" class="icon" />
        </div>
        <span class="sidebar-container-main-item-name">{{ item.name }}</span>
      </div>
    </div>
  </div>
</template>

<style scoped lang="scss">
.sidebar-container {
  width: 230px;
  height: 100%;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  background-color: transparent;

  &-main {
    overflow-y: auto;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    position: relative;
    width: 100%;
    height: 100%;
    .sidebar-container-main-item.active::before {
      content: "";
      position: absolute;
      left: 0;
      top: 0;
      bottom: 0;
      width: 8px;
      background-color: #4293ee;
    }

    .active {
      color: #4293ee;
      background-color: #fff;
    }

    &-item {
      display: flex;
      flex-direction: column;
      justify-content: center;
      align-items: center;
      position: relative;
      width: 100%;
      height: 166px;

      &-icon {
        display: flex;
        flex-direction: row;
        align-items: center;

        .icon {
          width: 54px;
          height: 54px;
        }
      }

      &-name {
        margin-top: 20px;
        font-size: 24px;
      }
    }
  }
}
</style>
